﻿Option Strict On

'
'             H2
'     June 13, 2009
'     1388 / 03 / 23
'Download: http://support.h02.ir/fwlink/?LinkId=1005501287
'

Public Class frmMain

    Private m_Interface As ICompileClass 'Run1
    Private m_Method As System.Reflection.MethodInfo 'Run2

    Private Sub f_Code_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles f_Code.TextChanged
        Me.m_Method = Nothing
        Me.m_Interface = Nothing
    End Sub

    Private Sub btnRun1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun1.Click
        If (Me.m_Interface Is Nothing) Then
            Me.Compile1()
            If (Me.m_Interface Is Nothing) Then Return
        End If

        Me.f_Y.Value = Convert.ToDecimal(Me.m_Interface.Fx(Decimal.ToDouble(Me.f_X.Value)))
    End Sub

    Private Sub btnRun2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun2.Click
        If (Me.m_Method Is Nothing) Then
            Me.Compile2()
            If (Me.m_Method Is Nothing) Then Return
        End If

        Me.f_Y.Value = Convert.ToDecimal(Me.m_Method.Invoke(Nothing, New Object() {Decimal.ToDouble(Me.f_X.Value)}))
    End Sub

    Private Sub Compile1()
        Me.m_Interface = Nothing
        '--------------

        Dim code As New System.Text.StringBuilder(1024)
        code.AppendLine("Imports System, System.Math, System.Windows.Forms")
        code.AppendLine("Public Class Class1")
        code.AppendLine("Implements RuntimeCompile.ICompileClass")
        code.Append(Me.f_StartCode.Text.Replace("Shared", String.Empty))
        code.AppendLine(" Implements RuntimeCompile.ICompileClass.Fx")
        code.AppendLine(Me.f_Code.Text)
        code.AppendLine(Me.f_EndCode.Text)
        code.AppendLine("End Class")
        '--------------

        Dim opt As New System.CodeDom.Compiler.CompilerParameters()
        opt.GenerateInMemory = True
        opt.GenerateExecutable = False
        opt.Evidence = System.Reflection.Assembly.GetExecutingAssembly().Evidence
        opt.ReferencedAssemblies.Add("System.dll")
        opt.ReferencedAssemblies.Add("System.Windows.Forms.dll")
        opt.ReferencedAssemblies.Add("RuntimeCompile.exe")
        '--------------

        Dim compiler As System.CodeDom.Compiler.CodeDomProvider = System.CodeDom.Compiler.CodeDomProvider.CreateProvider("VB")
        Dim ret As System.CodeDom.Compiler.CompilerResults = compiler.CompileAssemblyFromSource(opt, New String() {code.ToString()})

        If ((ret.Errors IsNot Nothing) AndAlso (ret.Errors.Count > 0)) Then
            System.Windows.Forms.MessageBox.Show(Me, ret.Errors(0).ErrorText, "Error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error)
            Return
        End If
        '--------------

        Dim type As Type = ret.CompiledAssembly.GetType("Class1")
        Me.m_Interface = TryCast(System.Activator.CreateInstance(type), ICompileClass)
    End Sub

    Private Sub Compile2()
        Me.m_Method = Nothing
        '--------------

        Dim code As New System.Text.StringBuilder(1024)
        code.AppendLine("Imports System, System.Math, System.Windows.Forms")
        code.AppendLine("Public Class Class1")
        code.AppendLine(Me.f_StartCode.Text)
        code.AppendLine(Me.f_Code.Text)
        code.AppendLine(Me.f_EndCode.Text)
        code.AppendLine("End Class")
        '--------------

        Dim opt As New System.CodeDom.Compiler.CompilerParameters()
        opt.GenerateInMemory = True
        opt.GenerateExecutable = False
        opt.Evidence = System.Reflection.Assembly.GetExecutingAssembly().Evidence
        opt.ReferencedAssemblies.Add("System.dll")
        opt.ReferencedAssemblies.Add("System.Windows.Forms.dll")
        '--------------

        Dim compiler As System.CodeDom.Compiler.CodeDomProvider = System.CodeDom.Compiler.CodeDomProvider.CreateProvider("VB")
        Dim ret As System.CodeDom.Compiler.CompilerResults = compiler.CompileAssemblyFromSource(opt, New String() {code.ToString()})

        If ((ret.Errors IsNot Nothing) AndAlso (ret.Errors.Count > 0)) Then
            System.Windows.Forms.MessageBox.Show(Me, ret.Errors(0).ErrorText, "Error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error)
            Return
        End If
        '--------------

        Dim type As Type = ret.CompiledAssembly.GetType("Class1")
        Me.m_Method = type.GetMethod("Fx")
    End Sub






    <STAThread()> Public Shared Sub Main()
        System.Windows.Forms.Application.EnableVisualStyles()
        System.Windows.Forms.Application.Run(New frmMain())
    End Sub

End Class

Public Interface ICompileClass
    Function Fx(ByVal X As Double) As Double
End Interface